<?php

namespace Drupal\media_pdf_thumbnail\Manager;

use Drupal\Core\Logger\LoggerChannel;
use Spatie\PdfToImage\Pdf;

/**
 * Class MediaPdfThumbnailImagickManager.
 *
 * @package Drupal\media_pdf_thumbnail\Manager
 */
class MediaPdfThumbnailImagickManager {

  protected $logger;

  /**
   * MediaPdfThumbnailImagickManager constructor.
   *
   * @param \Drupal\Core\Logger\LoggerChannel $loggerChannel
   */
  public function __construct(LoggerChannel $loggerChannel) {
    $this->logger = $loggerChannel;
  }

  /**
   * Generate image from PDF file.
   *
   * @param string $source
   *   File source.
   * @param string $target
   *   File target.
   *
   * @return string
   *   File path.
   *
   */
  public function generateImage($source, $target) {
    try {
      $pdf = new Pdf($source);
      $pdf->saveImage($target);
    }
    catch (\Exception $e) {
      $this->logger->error($e->getMessage(), ['Media Pdf Thumbnail']);
      return FALSE;
    }
    return TRUE;
  }

}
